# Starting code for Homework 9
#----------------------------------------------------------------------------
# initialization
import os,sys;os.chdir(os.getcwd())
sys.path.extend([os.getcwd(),os.path.join(os.path.expanduser('~'),'Documents')])
from hw9tester import *
#----------------------------------------------------------------------------
# Part 1: paste in your code for the five functions from Lab 9 listed below.
# You DO NOT need to include any other code from Lab 9.

# inBounds
# searchDirection
# searchPosition
# searchGrid
# findwords



#----------------------------------------------------------------------------
# Part 2: put your improved version of the playTTT function here. Please
# DO NOT include any of the other supporting Tic-Tac-Toe functions we wrote
# in class (e.g. printBoard, nextPosition, checkForWin, makeMove, etc.)



#----------------------------------------------------------------------------
# Part 3: Zip code database

# we wrote this in class
def makeZipcodeDatabase(filename):
    f = open(filename, 'r')
    allLines = f.readlines()
    f.close()
    database = {}
    for line in allLines:
        line = line.strip()
        zipcode, lat, lon, city, county, state, pop = line.split(",")
        latitude = float(lat)
        longitude = float(lon)
        population = int(pop)
        coordinates = [latitude, longitude]
        record = {'city': city, 'state': state, 'zip': zipcode,
                  'county': county, 'pop': population, 'coords': coordinates}
        database[zipcode] = record
    return database

# we wrote this in class
def lookupByZip(database):
    zipcode = input("Enter a zipcode: ")
    if zipcode in database:
        record = database[zipcode]
        return record
    else:
        print("Nothing found.")
        return None

# we wrote this in class
def lookupByCity(database):
    location = input("Enter city, state: ")
    city, state = location.split(",")
    state = state.strip().upper()
    for zipcode in database:
        record = database[zipcode]
        if record['city'] == city and record['state'] == state:
            return record
        else:
            pass
    print("Nothing found.")
    return None

# geographicDistance takes two locations specified as latitude/longitude
# values in degrees, and returns the distance in miles between them.
# See https://en.wikipedia.org/wiki/Great-circle_distance for more info.

def geographicDistance(lat1, lon1, lat2, lon2):
    from math import radians, acos, sin, cos
    # convert from degrees to radians
    lat1, lon1 = radians(lat1), radians(lon1)
    lat2, lon2 = radians(lat2), radians(lon2)
    R = 3963  # radius of the Earth in miles
    d = R * acos(min(1, sin(lat1)*sin(lat2) + cos(lat1)*cos(lat2)*cos(lon2-lon1)))
    return round(d, 1)

# constructs a small version of the zipcode database for testing
db = makeZipcodeDatabase("zipDataSample.txt")

# constructs the full version of the zipcode database
#db = makeZipcodeDatabase("zipDataAll.txt")

# put your new zipcode functions here

